import { __decorate } from 'tslib';
import { EventEmitter, Input, Output, Component, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';

let NgnMultiSelectComponent = class NgnMultiSelectComponent {
    constructor() {
        this.inputValue = "";
        this.inputValuePlaceholder = "Search by item";
        this.selectedItems = [];
        this.autocomplete = "off";
        this.isShown = false;
        this.data = new EventEmitter();
    }
    selectItem() {
        this.isShown = true;
    }
    isSelected(selectedItem) {
        return this.selectedItems.findIndex(id => id === selectedItem.id) > -1
            ? true
            : false;
    }
    listsuggestion(selectedItem) {
        if (this.selectedItems.length === 0) {
            this.firstItemSelect = selectedItem.name;
        }
        this.selectedItems.find(id => id === selectedItem.id)
            ? (this.selectedItems = this.selectedItems.filter(id => id !== selectedItem.id))
            : this.selectedItems.push(selectedItem.id);
        this.data.emit(this.selectedItems);
    }
    deletelists() {
        this.selectedItems = [];
        this.firstItemSelect = "";
        this.data.emit(this.selectedItems);
    }
};
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "inputValue", void 0);
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "inputValuePlaceholder", void 0);
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "lists", void 0);
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "selectedItems", void 0);
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "autocomplete", void 0);
__decorate([
    Input()
], NgnMultiSelectComponent.prototype, "isShown", void 0);
__decorate([
    Output()
], NgnMultiSelectComponent.prototype, "data", void 0);
NgnMultiSelectComponent = __decorate([
    Component({
        selector: "ngn-multi-select",
        template: `
    <div class="select">
      <div class="select__container">
        <div
          class="select__selected-items"
          *ngIf="selectedItems.length"
          (click)="deletelists()"
        >
          <span class="selected-length">
            {{
              selectedItems.length <= 1 ? firstItemSelect : selectedItems.length
            }}
            selected
          </span>
          <span class="delete-icon">&#10006;</span>
        </div>

        <input
          type="text"
          name="select"
          class="select__input"
          [(ngModel)]="inputValue"
          [autocomplete]="autocomplete"
          [placeholder]="inputValuePlaceholder"
          (click)="selectItem()"
        />
      </div>

      <ul class="select__list scrollbar" *ngIf="isShown">
        <li
          *ngFor="let list of lists"
          (click)="listsuggestion(list)"
          [class.selected]="isSelected(list)"
        >
          {{ list.name }}
        </li>
      </ul>
    </div>
  `,
        styles: [".select{text-transform:capitalize;position:relative}.select__container{display:flex;border:1px solid #e6ebf3;border-radius:.25rem}.select__selected-items{font-weight:700;position:relative}.select__selected-items span{cursor:pointer;position:absolute;color:red;top:.7rem;right:.3rem}.select__selected-items span.selected-length{position:static;display:inline-block;width:120px;line-height:2.5rem;text-align:center;padding-right:1rem;padding-left:.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000}.select__input{width:100%;height:2.5rem;background-color:#f7f9fc;padding-right:1.5rem;padding-left:.5rem;border:none;border-radius:.25rem}.select__input::-webkit-input-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::-moz-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::-ms-input-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::placeholder{color:#8f9bb3;text-transform:capitalize}.select__input:focus{box-shadow:none!important;outline:0;border-color:#e6ebf3!important}.select__list{width:100%;max-height:250px;margin-top:.5rem;border:1px solid #f7f9fc;border-radius:.25rem;box-shadow:0 1rem 1rem rgba(0,0,0,.08);overflow-y:scroll;background-color:#fff;position:absolute;bottom:initial;left:0;z-index:9;list-style:none;padding-left:0}.select__list li{padding:.5rem;cursor:pointer}.select__list li:hover{background-color:#e6e6e6}.select__list li.selected{background-color:#4b267f;color:#fff}"]
    })
], NgnMultiSelectComponent);

let NgnMultiSelectModule = class NgnMultiSelectModule {
};
NgnMultiSelectModule = __decorate([
    NgModule({
        declarations: [NgnMultiSelectComponent],
        imports: [BrowserModule, FormsModule],
        exports: [NgnMultiSelectComponent]
    })
], NgnMultiSelectModule);

/*
 * Public API Surface of ngn-multi-select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgnMultiSelectComponent, NgnMultiSelectModule };
//# sourceMappingURL=ngn-multi-select.js.map
