import { __decorate } from 'tslib';
import { EventEmitter, Input, Output, Component, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';

var NgnMultiSelectComponent = /** @class */ (function () {
    function NgnMultiSelectComponent() {
        this.inputValue = "";
        this.inputValuePlaceholder = "Search by item";
        this.selectedItems = [];
        this.autocomplete = "off";
        this.isShown = false;
        this.data = new EventEmitter();
    }
    NgnMultiSelectComponent.prototype.selectItem = function () {
        this.isShown = true;
    };
    NgnMultiSelectComponent.prototype.isSelected = function (selectedItem) {
        return this.selectedItems.findIndex(function (id) { return id === selectedItem.id; }) > -1
            ? true
            : false;
    };
    NgnMultiSelectComponent.prototype.listsuggestion = function (selectedItem) {
        if (this.selectedItems.length === 0) {
            this.firstItemSelect = selectedItem.name;
        }
        this.selectedItems.find(function (id) { return id === selectedItem.id; })
            ? (this.selectedItems = this.selectedItems.filter(function (id) { return id !== selectedItem.id; }))
            : this.selectedItems.push(selectedItem.id);
        this.data.emit(this.selectedItems);
    };
    NgnMultiSelectComponent.prototype.deletelists = function () {
        this.selectedItems = [];
        this.firstItemSelect = "";
        this.data.emit(this.selectedItems);
    };
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "inputValue", void 0);
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "inputValuePlaceholder", void 0);
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "lists", void 0);
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "selectedItems", void 0);
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "autocomplete", void 0);
    __decorate([
        Input()
    ], NgnMultiSelectComponent.prototype, "isShown", void 0);
    __decorate([
        Output()
    ], NgnMultiSelectComponent.prototype, "data", void 0);
    NgnMultiSelectComponent = __decorate([
        Component({
            selector: "ngn-multi-select",
            template: "\n    <div class=\"select\">\n      <div class=\"select__container\">\n        <div\n          class=\"select__selected-items\"\n          *ngIf=\"selectedItems.length\"\n          (click)=\"deletelists()\"\n        >\n          <span class=\"selected-length\">\n            {{\n              selectedItems.length <= 1 ? firstItemSelect : selectedItems.length\n            }}\n            selected\n          </span>\n          <span class=\"delete-icon\">&#10006;</span>\n        </div>\n\n        <input\n          type=\"text\"\n          name=\"select\"\n          class=\"select__input\"\n          [(ngModel)]=\"inputValue\"\n          [autocomplete]=\"autocomplete\"\n          [placeholder]=\"inputValuePlaceholder\"\n          (click)=\"selectItem()\"\n        />\n      </div>\n\n      <ul class=\"select__list scrollbar\" *ngIf=\"isShown\">\n        <li\n          *ngFor=\"let list of lists\"\n          (click)=\"listsuggestion(list)\"\n          [class.selected]=\"isSelected(list)\"\n        >\n          {{ list.name }}\n        </li>\n      </ul>\n    </div>\n  ",
            styles: [".select{text-transform:capitalize;position:relative}.select__container{display:flex;border:1px solid #e6ebf3;border-radius:.25rem}.select__selected-items{font-weight:700;position:relative}.select__selected-items span{cursor:pointer;position:absolute;color:red;top:.7rem;right:.3rem}.select__selected-items span.selected-length{position:static;display:inline-block;width:120px;line-height:2.5rem;text-align:center;padding-right:1rem;padding-left:.5rem;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;color:#000}.select__input{width:100%;height:2.5rem;background-color:#f7f9fc;padding-right:1.5rem;padding-left:.5rem;border:none;border-radius:.25rem}.select__input::-webkit-input-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::-moz-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::-ms-input-placeholder{color:#8f9bb3;text-transform:capitalize}.select__input::placeholder{color:#8f9bb3;text-transform:capitalize}.select__input:focus{box-shadow:none!important;outline:0;border-color:#e6ebf3!important}.select__list{width:100%;max-height:250px;margin-top:.5rem;border:1px solid #f7f9fc;border-radius:.25rem;box-shadow:0 1rem 1rem rgba(0,0,0,.08);overflow-y:scroll;background-color:#fff;position:absolute;bottom:initial;left:0;z-index:9;list-style:none;padding-left:0}.select__list li{padding:.5rem;cursor:pointer}.select__list li:hover{background-color:#e6e6e6}.select__list li.selected{background-color:#4b267f;color:#fff}"]
        })
    ], NgnMultiSelectComponent);
    return NgnMultiSelectComponent;
}());

var NgnMultiSelectModule = /** @class */ (function () {
    function NgnMultiSelectModule() {
    }
    NgnMultiSelectModule = __decorate([
        NgModule({
            declarations: [NgnMultiSelectComponent],
            imports: [BrowserModule, FormsModule],
            exports: [NgnMultiSelectComponent]
        })
    ], NgnMultiSelectModule);
    return NgnMultiSelectModule;
}());

/*
 * Public API Surface of ngn-multi-select
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgnMultiSelectComponent, NgnMultiSelectModule };
//# sourceMappingURL=ngn-multi-select.js.map
